<script setup lang="ts">
import { computed, onMounted, ref, useSlots } from "vue";
import { Modal } from "bootstrap";
import BootstrapModal from "@/components/modals/BootstrapModal.vue";

const props = defineProps<{
  modalId: string;
  objectNameDelete?: string;
  backModalId?: string;
  disabled?: boolean;
  deleteType?: string;
}>();

const confirmDelete = ref<boolean>(false);
const emit = defineEmits<{
  (e: "confirm-delete"): void;
}>();
const slots = useSlots();

let deleteModal: Modal | null = null;
const randomIDSuffix = Math.random().toString(16).substring(2, 8);

function modalClosed() {
  confirmDelete.value = false;
}

function deleteStuff() {
  emit("confirm-delete");
  deleteModal?.hide();
  confirmDelete.value = false;
}

const deleteButtonDisabled = computed<boolean>(() => {
  if (slots.confirmDelete != undefined) {
    return props.disabled;
  }
  return !confirmDelete.value || props.disabled;
});

onMounted(() => {
  deleteModal = Modal.getOrCreateInstance("#" + props.modalId);
});
</script>

<template>
  <bootstrap-modal
    :modal-id="props.modalId"
    :static-backdrop="true"
    :modal-label="`Confirm Delete ${props.deleteType != undefined ? props.deleteType + ' ' : ''}Modal`"
    v-on="{ 'hidden.bs.modal': modalClosed }"
  >
    <template #header>Are you absolutely sure?</template>
    <template #body>
      <slot name="body">
        <p>
          Are you sure you want to delete
          <span v-if="props.objectNameDelete">{{
            props.objectNameDelete
          }}</span>
        </p>
      </slot>
      <slot name="confirmDelete">
        <div class="form-check">
          <input
            :id="'checkConfirmDelete' + randomIDSuffix"
            v-model="confirmDelete"
            class="form-check-input"
            type="checkbox"
          />
          <label
            class="form-check-label"
            :for="'checkConfirmDelete' + randomIDSuffix"
          >
            <strong>Yes</strong>, I am sure.
          </label>
        </div>
      </slot>
    </template>
    <template #footer>
      <button
        v-if="backModalId"
        type="button"
        class="btn btn-secondary"
        :data-bs-target="'#' + props.backModalId"
        data-bs-toggle="modal"
      >
        Back
      </button>
      <button
        v-else
        type="button"
        class="btn btn-secondary"
        data-bs-dismiss="modal"
      >
        Close
      </button>
      <button
        type="button"
        class="btn btn-danger"
        :disabled="deleteButtonDisabled"
        @click="deleteStuff"
      >
        Yes, delete
        <span v-if="props.deleteType" class="text-lowercase">{{
          props.deleteType
        }}</span>
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
